#include <algorithm>
#include <cstdio>
#include <vector>

//#define MAX_LVL 29
#define MAX_LVL 4

struct TreeNode {
	int count = 0;
	int and_n;
	TreeNode *left = nullptr, *right = nullptr;

	TreeNode(int and_n = (1 << (MAX_LVL+1)) - 1) : and_n(and_n) {}
	~TreeNode() {
		if (left)
			delete left;
		if (right)
			delete right;
	}
	void insert(int number, int level = MAX_LVL) {
		TreeNode **where = (number & (1 << level)) ? &right : &left;
		++count;
		and_n &= number;
		if (!level) {
			if (!*where)
				*where = new TreeNode(number);
			++(*where)->count;
		} else {
			if (!*where)
				*where = new TreeNode(number);
			(*where)->insert(number, level - 1);
		}
	}
	int findAtLeastK(int k, int level = MAX_LVL) {
		if (count < k)
			return 0;
		if (right) {
			if (right->count >= k)
				return right->and_n;
			right->and_n &= ~(1 << level);
			if (left) {
				left->join(right);
				right = nullptr;
			} else {
				left = right;
				right = nullptr;
			}
		}
		if (left && level)
			return left->findAtLeastK(k, level - 1);
		return 0;
	}
	void join(TreeNode *node) {
		count += node->count;
		and_n &= node->and_n;
		if (node->left) {
			if (left)
				left->join(node->left);
			else
				left = node;
		}
		if (node->right) {
			if (right)
				right->join(node->right);
			else
				right = node;
		}
	}
	void print() {
		printf("{%d,%d}(", count, and_n);
		if (left) left->print();
		printf(")[");
		if (right) right->print();
		putchar(']');
	}
};

int main() {
	int n, k, x;
	scanf("%d %d", &n, &k);
	TreeNode root;
	while (n--) {
		scanf("%d", &x);
		root.insert(x);
	}
	root.print();
	putchar('\n');
	printf("%d\n", root.findAtLeastK(k));
	root.print();
	putchar('\n');
}
